---
title: Axes
slug: Web/XPath/Axes
tags:
  - Transforming_XML_with_XSLT
  - XPath
  - XPath_Reference
  - XSLT
  - XSLT_Reference
---
<p>{{ XsltRef() }} There are thirteen different axes in the <a href="/en/XPath" title="en/XPath">XPath</a> specification. An axis represents a relationship to the context node, and is used to locate nodes relative to that node on the tree. The following is an extremely brief description of the thirteen available axes and the degree of support available in <a href="/en/Gecko" title="en/Gecko">Gecko</a>.</p>

<p>For further information on using XPath expressions, please see the <a href="/en/Transforming_XML_with_XSLT/For_Further_Reading" title="en/Transforming_XML_with_XSLT/For_Further_Reading">For Further Reading</a> section at the end of <a href="/en/Transforming_XML_with_XSLT" title="en/Transforming_XML_with_XSLT">Transforming XML with XSLT</a> document. Also see the <a href="http://www.w3.org/TR/xpath-30/#axes">'axes' section in the xpath spec</a>.</p>


<dl>
 <dt><a href="/en/XPath/Axes/ancestor" title="en/XPath/Axes/ancestor">ancestor</a></dt>
 <dd>Indicates all the ancestors of the context node beginning with the parent node and traveling through to the root node.</dd>
 <dt><a href="/en/XPath/Axes/ancestor-or-self" title="en/XPath/Axes/ancestor-or-self">ancestor-or-self</a></dt>
 <dd>Indicates the context node and all of its ancestors, including the root node.</dd>
 <dt><a href="/en/XPath/Axes/attribute" title="en/XPath/Axes/attribute">attribute</a></dt>
 <dd>Indicates the attributes of the context node. Only elements have attributes. This axis can be abbreviated with the at sign (<code>@</code>).</dd>
 <dt><a href="/en/XPath/Axes/child" title="en/XPath/Axes/child">child</a></dt>
 <dd>Indicates the children of the context node. If an XPath expression does not specify an axis, this is understood by default. Since only the root node or element nodes have children, any other use will select nothing.</dd>
 <dt><a href="/en/XPath/Axes/descendant" title="en/XPath/Axes/descendant">descendant</a></dt>
 <dd>Indicates all of the children of the context node, and all of their children, and so forth. Attribute and namespace nodes are <strong>not</strong> included - the <code>parent</code> of an <code>attribute</code> node is an element node, but <code>attribute</code> nodes are not the children of their parents.</dd>
 <dt><a href="/en/XPath/Axes/descendant-or-self" title="en/XPath/Axes/descendant-or-self">descendant-or-self</a></dt>
 <dd>Indicates the context node and all of its descendants. Attribute and namespace nodes are <strong>not</strong> included - the <code>parent</code> of an <code>attribute</code> node is an element node, but <code>attribute</code> nodes are not the children of their parents.</dd>
 <dt><a href="/en/XPath/Axes/following" title="en/XPath/Axes/following">following</a></dt>
 <dd>Indicates all the nodes that appear after the context node, except any <code>descendant</code>, <code>attribute</code>, and <code>namespace</code> nodes.</dd>
 <dt><a href="/en/XPath/Axes/following-sibling" title="en/XPath/Axes/following-sibling">following-sibling</a></dt>
 <dd>Indicates all the nodes that have the same parent as the context node and appear after the context node in the source document.</dd>
 <dt><a href="/en/XPath/Axes/namespace" title="en/XPath/Axes/namespace">namespace</a> <em>(not supported)</em></dt>
 <dd>Indicates all the nodes that are in scope for the context node. In this case, the context node must be an element node.</dd>
 <dt><a href="/en/XPath/Axes/parent" title="en/XPath/Axes/parent">parent</a></dt>
 <dd>Indicates the single node that is the parent of the context node. It can be abbreviated as two periods (<code>..</code>).</dd>
 <dt><a href="/en/XPath/Axes/preceding" title="en/XPath/Axes/preceding">preceding</a></dt>
 <dd>Indicates all the nodes that precede the context node in the document except any <code>ancestor</code>, <code>attribute</code> and <code>namespace</code> nodes.</dd>
 <dt><a href="/en/XPath/Axes/preceding-sibling" title="en/XPath/Axes/preceding-sibling">preceding-sibling</a></dt>
 <dd>Indicates all the nodes that have the same parent as the context node and appear before the context node in the source document.</dd>
 <dt><a href="/en/XPath/Axes/self" title="en/XPath/Axes/self">self</a></dt>
 <dd>Indicates the context node itself. It can be abbreviated as a single period (<code>.</code>).</dd>
</dl>

<p>{{QuickLinksWithSubpages("/en-US/docs/Web/XPath")}}</p>
